/*----------------------------------------------------------------------------*

	LinuxInfo_arm.c
		by Alex Buell
			Added March 1999

 ----------------------------------------------------------------------------- 

	Handles the ARM architecture	

 ----------------------------------------------------------------------------- 

	HISTORY

	1.0.8	Ported to ARM

 -----------------------------------------------------------------------------*/

#include "linuxinfo.h"

#ifdef system_arm

void GetHardwareInfo(struct hw_stat *hw)
{
	int processors = 0; 
	float bogomips = 0.0;
	float tempbogo;
	float tempMHz = 0.0;
	LONGLONG memory = 0;

	char temp_string[BUFSIZ], temp_string2[BUFSIZ];
	char chip[BUFSIZ], vendor[BUFSIZ], model[BUFSIZ], Mhz[BUFSIZ];

	char *p;

	struct stat st_buf;

	while (!feof(cpuinfo_file)) 
	{
		fgets(temp_string, BUFSIZ, cpuinfo_file); /* read the whole of the line */

		if (splitstring(temp_string, temp_string2))
		{
			// New style 
			if (strncmp(temp_string, "Processor", strlen("Processor")) == 0)
			{
				if (strncmp(temp_string2, "Intel sa110", strlen("Intel sa110")) == 0)
				{
					strcpy(vendor, "Intel");
					strcpy(model, "SA110");
				}
				processors++;
			}

			// Old style
			if (strncmp(temp_string, "Type", strlen("Type")) == 0)
			{
				if (strncmp(temp_string2, "sa110", strlen("sa110")) == 0)
				{
					strcpy(vendor, "Intel");
					strcpy(model, "SA110");
				}
				processors++;
			}

			if (strncmp(temp_string, "Type", strlen("Type")) == 0)
				processors++;

			if (strncmp(temp_string, "cpu MHz", strlen("cpu MHz")) == 0)
				tempMHz = atol(temp_string2);

			if (strncmp(temp_string, "BogoMips", strlen("BogoMips")) == 0)
				bogomips = bogomips + atof(temp_string2);
		}

		
	}

	stat(MEMORY_FILE, &st_buf);
	memory = st_buf.st_size;
	memory /= 1024; memory /= 1024;
	sprintf(hw->hw_memory, "%ld", (long int)memory);

	hw->hw_processors = processors;

	sprintf(hw->hw_cpuinfo, "%s %s", vendor, model);
	sprintf(hw->hw_bogomips, "%0.2f", bogomips);
	if (tempMHz == 0.0)
		sprintf(hw->hw_megahertz, "Unknown");
	else
		sprintf(hw->hw_megahertz, "%d", (int)tempMHz);
}

#endif /* system_arm */
